#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_PNM_Image.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Wizard.H>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <FL/Fl_Text_Display.H>
#include <iostream>

char *text_display(char* input_text)
{

	char *text;
	text = (char*)malloc(1024*sizeof(char));
	char *text1, *text2, *text3, *text4, *text5, *text6;
	text1 = (char*)malloc(1024*sizeof(char));
	text2 = (char*)malloc(1024*sizeof(char));
	text3 = (char*)malloc(1024*sizeof(char));
	text4 = (char*)malloc(1024*sizeof(char));
	text5 = (char*)malloc(1024*sizeof(char));
	text6 = (char*)malloc(1024*sizeof(char));
	
	FILE *input; input = fopen(input_text,"r");
	int a11, a12, a13, a21, a22, a23, a31, a32, a33;
	
	fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
	fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
	fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
	
	if (a12==1)
		sprintf(text1,"Red object is in front of Green object \n");
	
	if (a13==1)
		sprintf(text2,"Red object is in front of Blue object \n");
		
	if (a21==1)
		sprintf(text3,"Green object is in front of Red object \n");
		
	if (a23==1)
		sprintf(text4,"Green object is in front of Blue object \n");
		
	if (a31==1)
		sprintf(text5,"Blue object is in front of Red object \n");
		
	if (a32==1)
		sprintf(text6,"Blue object is in front of Green object");
	
	sprintf(text, "\n %s \n %s \n %s \n %s \n %s \n %s", text1, text2, text3, text4, text5, text6);
	
	free(text1); free(text2); free(text3); free(text4); free(text5); free(text6);
	
	return text;

}

/*void write(int a11, int a12, int a13, int a21, int a22, int a23, int a31, int a32, int a33)
{
	FILE *output; output = fopen("computed_occlusions.txt","w");
	fprintf(output, "%d %d %d %d %d %d %d %d %d \n", a11, a12, a13, a21, a22, a23, a31, a32, a33);
}*/






class Occlusion_Selector_Button : public Fl_Button{

public:

int index_1; int index_2;

int handle(int e)
{
	FILE *input; 
	int a11, a12, a13, a21, a22, a23, a31, a32, a33;
	FILE *output;
	input = fopen("computed_occlusions.txt","r");
	fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
	fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
	fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
	output = fopen("computed_occlusions.txt","r+");
	
	switch(e){
		case FL_PUSH:
			this->deactivate();
			Fl::check();
			input = fopen("computed_occlusions.txt","r");
			fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
			fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
			fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
			fclose(input);
			output = fopen("computed_occlusions.txt","r+");
			
			if (index_1 == 1 && index_2 == 2){
				a12 = 1; a21 = -1;
				if (a23 == 1){
					a13 = 1; a31 = -1;
				}
			}
			
			if (index_1 == 1 && index_2 == 3){
				a13 = 1; a31 = -1;
				if (a32 == 1){
					a12 = 1; a21 = -1;
				}
			}
			
			if (index_1 == 2 && index_2 == 1){
				a21 = 1; a12 = -1;
				if (a13 == 1){
					a23 = 1; a32 = -1;
				}				
			}
			
			if (index_1 == 2 && index_2 == 3){
				a23 = 1; a32 = -1;
				if (a31 == 1){
					a21 = 1; a12 = -1;
				}
			}
			
			if (index_1 == 3 && index_2 == 1){
				a31 = 1; a13 = -1;
				if (a12 == 1){
					a32 = 1; a23 = -1;
				}
			}
			
			if (index_1 == 3 && index_2 == 2){
				a32 = 1; a23 = -1;
				if (a21 == 1){
					a31 = 1; a13 = -1;
				}
				
			}

			fprintf(output, "%d %d %d %d %d %d %d %d %d", a11, a12, a13, a21, a22, a23, a31, a32, a33);
			fclose(output);
			
			break;
			return e;
		case FL_RELEASE:
			this->activate();
			break;
			return e;
		}
	return e;
}

Occlusion_Selector_Button(int X, int Y, int W, int H, const char *label, int ind_1, int ind_2):Fl_Button(X,Y,W,H,label)
	{
		index_1 = ind_1;
		index_2 = ind_2;
	}

};



class Refresh_Button : public Fl_Button{

public:

Fl_Text_Buffer *refresh_buff;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
			this->deactivate();
			Fl::check();
			char *current_text;
			current_text = text_display("computed_occlusions.txt");
			refresh_buff->text(current_text);
			break;
			return e;
		case FL_RELEASE:
			this->activate();
			break;
			return e;	
		}
	return e;
}

void set_buf(Fl_Text_Buffer *buffer){refresh_buff = buffer;}
Refresh_Button(int X, int Y, int W, int H, const char *label):Fl_Button(X,Y,W,H,label){}

};


void done_cb(Fl_Widget*,void*) { exit(0); }


int main(int argc, char *argv[])
{
	Fl::scheme("gtk+");
	Fl_Window *win = new Fl_Window(0,0,750,600, "Window 2 - Order Setting");
	
	Fl_Box *box1;
	Fl_PNM_Image *image1;
	Fl_Box *box2;
	Fl_PNM_Image *image2;
	
	box1 = new Fl_Box(30, 30, 250, 250);
	image1 = new Fl_PNM_Image("master_camera.ppm");
	box1->image(image1);
	
	box2 = new Fl_Box(30, 310, 250, 250);	
	image2 = new Fl_PNM_Image("master_camera_objects.ppm");
	box2->image(image2);
	
	Fl_Text_Buffer *buff = new Fl_Text_Buffer();
	Fl_Text_Display *disp = new Fl_Text_Display(310, 300, 300, 200, "Occlusions");
	disp->buffer(buff);
	char *text_example;
	text_example = text_display("computed_occlusions.txt");
	buff->text(text_example);
	
	Refresh_Button *refresh;
	refresh = new Refresh_Button(610,390,100,25, "Refresh");
	refresh->set_buf(buff);
	
	Occlusion_Selector_Button *red_green;
	red_green = new Occlusion_Selector_Button(310,30,400,25,"Red object in front of Green object", 1, 2);
	
	Occlusion_Selector_Button *red_blue;
	red_blue = new Occlusion_Selector_Button(310,55,400,25,"Red object in front of Blue object", 1, 3);
	
	Occlusion_Selector_Button *green_red;
	green_red = new Occlusion_Selector_Button(310,100,400,25,"Green object in front of Red object", 2, 1);
	
	Occlusion_Selector_Button *green_blue;
	green_blue = new Occlusion_Selector_Button(310,125,400,25,"Green object in front of Blue object", 2, 3);
	
	Occlusion_Selector_Button *blue_red;
	blue_red = new Occlusion_Selector_Button(310,170,400,25,"Blue object in front of Red object", 3, 1);
	
	Occlusion_Selector_Button *blue_green;
	blue_green = new Occlusion_Selector_Button(310,195,400,25,"Blue object in front of Green object", 3, 2);

	Fl_Button *done = new Fl_Button(610,540,100,25,"Done"); done->callback(done_cb);
	
	win->end();
	
	win->show();
	
	return(Fl::run());

}
