#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_PNM_Image.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Wizard.H>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <FL/Fl_Text_Display.H>
#include <iostream>


int convert(int i, int j, int n)
{
int a;
a = (i*n + j);
return a;
}

int convert2(int i, int j, int n, int k)
{
int a;
a = (i*n + j)*3 + k;
return a;
}

int my_mod(int a, int b)
{
	if (a>=0)
		return a%b;
	else
		return (a+b)%b;

}


int *image_to_matrix(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);

	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	fscanf(input,"%3s",word);



	int *array;
	array = (int*)malloc(m*n*3*sizeof(int));
	int w; int i2; int j2; int k2;
	for (i2=0;i2<m;++i2){
		for (j2=0;j2<n;++j2){
			for (k2=0;k2<3;++k2){
			fscanf(input,"%d",&w);
			array[convert2(i2,j2,n,k2)] = w;
			}
		}
	}
	return array;
}

int image_width(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	int n; fscanf(input,"%d",&n);
	return n;
}

int image_height(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	return m;
}

int *image_to_matrix_not_gimp(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	
	char word[9];
	fscanf(input,"%2s",word);
	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	fscanf(input,"%3s",word);



	int *array;
	array = (int*)malloc(m*n*3*sizeof(int));
	int w; int i2; int j2; int k2;
	for (i2=0;i2<m;++i2){
		for (j2=0;j2<n;++j2){
			for (k2=0;k2<3;++k2){
			fscanf(input,"%d",&w);
			array[convert2(i2,j2,n,k2)] = w;
			}
		}
	}
	return array;
}



int *red_object(int *matrix, int m, int n)
{
	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; int j = 0; int aux = 0;
	for (i = 0; i<m; i++){
		for (j = 0; j<n; j++){
			if (matrix[convert2(i,j,n,0)]==255){
				answer[aux] = i; answer[aux+1] = j;
				aux = aux+2; 
			}
			
		}
	}
	return answer;
	
	/*AQUI ESTÁ RETORNANDO UM VETOR COM ZEROS SOBRANDO, SE NECESSÁRIO, FAZER ALGO QUE TIRE ESTES ZEROS*/	
}

int *green_object(int *matrix, int m, int n)
{
	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; int j = 0; int aux = 0;
	for (i = 0; i<m; i++){
		for (j = 0; j<n; j++){
			if (matrix[convert2(i,j,n,1)]==255){
				answer[aux] = i; answer[aux+1] = j;
				aux = aux+2; 
			}
			
		}
	}
	return answer;
	
	/*AQUI ESTÁ RETORNANDO UM VETOR COM ZEROS SOBRANDO, SE NECESSÁRIO, FAZER ALGO QUE TIRE ESTES ZEROS*/	
}

int *blue_object(int *matrix, int m, int n)
{
	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; int j = 0; int aux = 0;
	for (i = 0; i<m; i++){
		for (j = 0; j<n; j++){
			if (matrix[convert2(i,j,n,2)]==255){
				answer[aux] = i; answer[aux+1] = j;
				aux = aux+2; 
			}
			
		}
	}
	return answer;
	
	/*AQUI ESTÁ RETORNANDO UM VETOR COM ZEROS SOBRANDO, SE NECESSÁRIO, FAZER ALGO QUE TIRE ESTES ZEROS*/	
}

int *occlusions(int red_min, int red_max, int green_min, int green_max, int blue_min, int blue_max)
{
	int n = 3; //we're treating just three objects
	int *occlusion_matrix;
	occlusion_matrix = (int*)malloc(n*n*sizeof(int));
	
	if ((red_max < green_min) && (red_max!=0)){
		occlusion_matrix[convert(0,1,n)]=1;
		occlusion_matrix[convert(1,0,n)]=-1;
	}
	if ((red_max < blue_min) && (red_max!=0)){
		occlusion_matrix[convert(0,2,n)]=1;
		occlusion_matrix[convert(2,0,n)]=-1;
	}
	
	if ((green_max < red_min) && (green_max !=0)){
		occlusion_matrix[convert(1,0,n)]=1;
		occlusion_matrix[convert(0,1,n)]=-1;
	}
	
	if ((green_max < blue_min) && (green_max!=0)){
		occlusion_matrix[convert(1,2,n)]=1;
		occlusion_matrix[convert(2,1,n)]=-1;
	}
	
	if ((blue_max < red_min) && (blue_max!=0)){
		occlusion_matrix[convert(2,0,n)]=1;
		occlusion_matrix[convert(0,2,n)]=-1;
	}
	
	if ((blue_max < green_min) && (blue_max!=0)){
		occlusion_matrix[convert(2,1,n)]=1;
		occlusion_matrix[convert(1,2,n)]=-1;
	}
	
	return occlusion_matrix;	



}





int main(int argc, char *argv[])
{
	int n = image_width("master_camera_objects.ppm");
	int m = image_height("master_camera_objects.ppm");
	int *image = image_to_matrix("master_camera_objects.ppm");
	
	int *stereo_image = image_to_matrix_not_gimp("kz2_occ_master_camera_ascii.ppm");
	int k; int i; int j; int depth; int z;
		//printf("%d ",stereo_image[convert2(136,91,n,0)]);
	
	int *red = red_object(image, m, n);
		
	int red_min = 255; int red_max = 0;
	for (k=0;k<m*n/2;k++){
		if (red[2*k]!=0){
			i = red[2*k]; j = red[2*k+1];
				if (stereo_image[convert2(i,j,n,0)]!=255 || stereo_image[convert2(i,j,n,1)]!=0 || stereo_image[convert2(i,j,n,2)]!=0){
					depth = 255 - stereo_image[convert2(i,j,n,0)];
					//printf("depth = %d, i = %d, j = %d,,,", depth,i,j);
						if (depth > red_max)
							red_max = depth;
						if (depth < red_min)
							red_min = depth;
					}
				}
			}	
			
			
	/*printf("\n \n \n red_min=%d \n \n \n", red_min);
	printf("\n \n \n red_max=%d \n \n \n", red_max);*/
	
	
	int *green = green_object(image, m, n);
	
	int green_min = 255; int green_max = 0;
	for (k=0;k<m*n/2;k++){
		if (green[2*k]!=0){
			i = green[2*k]; j = green[2*k+1];
				if (stereo_image[convert2(i,j,n,0)]!=255 || stereo_image[convert2(i,j,n,1)]!=0 || stereo_image[convert2(i,j,n,2)]!=0){
					depth = 255 - stereo_image[convert2(i,j,n,0)];
					//printf("depth = %d, i = %d, j = %d,,,", depth,i,j);
						if (depth > green_max)
							green_max = depth;
						if (depth < green_min)
							green_min = depth;
					}
				}
			}
			
	/*printf("\n \n \n green_min=%d \n \n \n", green_min);
	printf("\n \n \n green_max=%d \n \n \n", green_max);*/
	
	
	
	int *blue = blue_object(image, m, n);
	
	int blue_min = 255; int blue_max = 0;
	for (k=0;k<m*n/2;k++){
		if (blue[2*k]!=0){
			i = blue[2*k]; j = blue[2*k+1];
				if (stereo_image[convert2(i,j,n,0)]!=255 || stereo_image[convert2(i,j,n,1)]!=0 || stereo_image[convert2(i,j,n,2)]!=0){
					depth = 255 - stereo_image[convert2(i,j,n,0)];
					//printf("depth = %d, i = %d, j = %d,,,", depth,i,j);
						if (depth > blue_max)
							blue_max = depth;
						if (depth < blue_min)
							blue_min = depth;
					}
				}
			}
			
	/*printf("\n \n \n blue_min=%d \n \n \n", blue_min);
	printf("\n \n \n blue_max=%d \n \n \n", blue_max);*/
	
	
	
	int *occlusion_matrix = occlusions(red_min,red_max,green_min,green_max,blue_min,blue_max);
	
	FILE *output;
	output = fopen("computed_occlusions.txt","w");
	
	z = 0;
	for (z=0;z<9;z++)
		fprintf(output, "%d ",occlusion_matrix[z]);

	fclose(output);
	
	
	
	
	
	/*Fl_Window *win = new Fl_Window(0,0,1000,1000, "Window 2 - Order Setting");
	
	Fl_Box *box1;
	Fl_PNM_Image *image1;
	Fl_Box *box2;
	Fl_PNM_Image *image2;
	
	box1 = new Fl_Box(30, 30, 250, 250);
	image1 = new Fl_PNM_Image("master_camera.ppm");
	box1->image(image1);
	
	box2 = new Fl_Box(30, 310, 250, 250);	
	image2 = new Fl_PNM_Image("master_camera_objects.ppm");
	box2->image(image2);
	
	win->end();
	
	win->show();
	
	return(Fl::run());*/
	
}
